const vueTempCompiler = require("v3-vue-template-compiler");
const VueComponentAnalyzer = require('./VueComponentAnalyzer');
const fs = require('fs');

class VueComponentFileAnalyzer {
    /**
     * 
     * @param {String} componentName 组件名称,实际为用户项目的pluginCode
     * @param {*} absPath 
     */
    constructor(componentName, absPath) {
        this.componentName = componentName;
        this.absPath = absPath;
        this.analyzer = this._analyze();
    }

    _analyze() {
        let content = fs.readFileSync(this.absPath);
        let rs = vueTempCompiler.parseComponent(String(content));
        let javascript = "";
        let domScript = "";
        if (rs.script) {
            javascript = rs.script.content;
        }
        if (rs.template) {
            domScript = rs.template.content;
        }
        return new VueComponentAnalyzer({
            componentName: this.componentName,
            domScript: domScript,
            javascript: javascript
        });
    }

    getComponent() {
        return this.analyzer.getComponent();
    }
}

module.exports = VueComponentFileAnalyzer;