/**
 * @author xujw 2018-7-31 17:13:51
 * 插件类型枚举
 */

module.exports = {
    widget: 'widget',
    resource: 'resource',
    window: 'window',
    /* 获取全部类型对应的中文提示 */
    getAllTips: function () {
        let tips = {};
        tips[this.widget] = '二次开发控件';
        tips[this.resource] = '资源构件';
        tips[this.window] = '窗体构件';
        return tips;
    },
    /* 获取对外提供的类型列表,通过增删返回的数组内容可以控制要对外提供的类型 */
    getTypeList: function () {
        return [this.widget, this.resource];
    },
    /**
     * 通过给定的编码返回对应的中文
     */
    getTextByCode: function (pluginType) {
        let text = '';
        this.getTypeList().forEach(type => {
            if (type == pluginType) {
                text = this.getAllTips()[pluginType];
            }
        });
        return text;
    },
    /* 获取中文提示文本,类型数量与对外提供的数量一致 */
    getTipsText: function () {
        let text = ' ';
        let allTips = this.getAllTips();
        this.getTypeList().forEach(type => {
            text += type + ':' + allTips[type] + ' ';
        });
        return text;
    },
    /**
     * 判断一个给定的类型是否为当前支持的类型,以对外提供的列表为准
     * @param {String} typeCheck 要判断的类型
     */
    isSupport: function (typeCheck) {
        this.getTypeList().forEach(type => {
            if (type == typeCheck) {
                return true;
            }
        });
        return false;
    }
}