/**
 * 根据命令创建引擎
 */
const Engine = require("./Engine");
const V3DevrcTask = require("./task/V3DevrcTask");
const ClearJarTask = require("./task/ClearJarTask");
const PackageTask = require("./task/PackageTask");
const InstallTask = require("./task/InstallTask");
const DeployTask = require("./task/DeployTask");
const UpdateTask = require("./task/UpdateTask");
const SyncTask = require("./task/SyncTask");
const VjsPatchTask = require('./task/VjsPatchTask');
exports.createEngine = function(command){
	let taskList = [];
	switch(command){
		case 'sync'    :
			taskList.push(new SyncTask());
			break; 
		case 'install' :
			taskList.push(new V3DevrcTask());
			taskList.push(new ClearJarTask());
			/*taskList.push(new PackageTask());
			打包任务集成到InstallTask内部执行
			*/
			taskList.push(new InstallTask());
			break;
		case 'deploy'  :
			taskList.push(new V3DevrcTask());
			taskList.push(new ClearJarTask());
			taskList.push(new InstallTask());
			taskList.push(new DeployTask());
			break;
		case 'apply' :
			taskList.push(new V3DevrcTask());
			taskList.push(new ClearJarTask());
			taskList.push(new InstallTask());
			taskList.push(new UpdateTask());
			taskList.push(new VjsPatchTask());
			break;
		default        :
			break;

	}
	return new Engine(taskList);
};