/**
 * 发布构件到Vstore
 */
const ITask = require("../ITask");
const PluginDeployer = require("../../http/PluginDeployer");
const configUtils = require('../../../../utils/ConfigUtils');

class DeployTask extends ITask{

	exe(ctx){
		return new Promise((resolve,reject)=>{			
			console.log("开始部署插件到VStore，请稍候...");
			let jar = ctx.get("jar");
			let deployer = new PluginDeployer({
				"jar":jar.getDist(),
				"source":jar.getSource(),
				"packageJson":configUtils.getPackageConfig(),
				"v3DevConfig":configUtils.getV3DevConfig(),
				"manifest":jar.getManifest()
			});
			let promise = deployer.deploy();
			promise.then(()=>{
				resolve();
			}).catch(err=>{
				reject(err);
			});
		});
	}
	
}

module.exports = DeployTask;