/**
 * 打包nodejs插件
 */
const ITask = require("../ITask");
const childProcess = require('child_process');
const widgetPathUtils = require("../../../utils/WidgetPathUtils");
const pathUtils = require("../../../../utils/PathUtils");
const fs = require("fs");

class PackageTask extends ITask {

	exe(ctx) {
		return new Promise((resolve, reject) => {
			childProcess.exec("npm pack", {
				cwd: pathUtils.getPluginPath()
			}, (error, stdout, stderr) => {
				if (error) {
					reject(error);
					return;
				}
				let tgzPaths = widgetPathUtils.getPluginTGzPath();
				let tgzPath = tgzPaths[0];
				//ctx.put("tgzPath", tgzPath);
				resolve(tgzPath);
			});
		});
	}

	handleError() {
		return new Promise((resolve, reject) => {
			try {
				let tgzPaths = widgetPathUtils.getPluginTGzPath();
				if (tgzPaths.length > 0) {
					let tgzPath = tgzPaths[0];
					fs.unlinkSync(tgzPath);
				}
				resolve();
			} catch (err) {
				reject(err);
			}
		});
	}

}

module.exports = PackageTask;