/**
 * 将插件更新到服务器
 */
const ITask = require("../ITask");
const configUtils = require('../../../../utils/ConfigUtils');
const PluginUpdater = require("../../http/PluginUpdater");

class UpdateTask extends ITask{

	exe(ctx) {
		return new Promise((resolve, reject) => {
			let jar = ctx.get("jar");
			let updater = new PluginUpdater({
				"jar": jar.getDist(),
				"packageJson": configUtils.getPackageConfig(),
				"manifest": jar.getManifest()
			});
			let promise = updater.update();
			promise.then(()=>{
				resolve();
			}).catch(err=>{
				reject(err);
			});
		});
	}
	
}

module.exports = UpdateTask;