const ITask = require("../ITask");
const configUtils = require("../../../../utils/ConfigUtils");
const ioUtils = require('../../../../utils/IOUtils');
const fs = require("fs");
/**
 * 清空.v3devrc文件中密码信息
 */
class V3DevrcTask extends ITask {

	constructor(params) {
		super(params);
		this.originalV3DevConfig = null;
	}

	exe(ctx) {
		return new Promise((resolve, reject) => {
			try {
				let cfgPath = configUtils.getV3DevConfigPath();
				if (fs.existsSync(cfgPath)) {
					this.originalV3DevConfig = configUtils.getV3DevConfig();
					let clone = {};
					Object.assign(clone, this.originalV3DevConfig);
					//将密码置空
					clone.pwd = null;
					clone.account = null;
					//clone.libType = null;
					clone.server = null;
					let promise = ioUtils.write(cfgPath,JSON.stringify(clone, null, "\t"));
					promise.then(()=>{
						resolve();
					}).catch(err=>{
						reject(err);
					});
				}
			} catch (e) {
				reject(e);
			}
		});
	}

	beforeDone() {
		return new Promise((resolve, reject) => {
			try {
				if (this.originalV3DevConfig) {
					let cfgPath = configUtils.getV3DevConfigPath();
					ioUtils.writeContent(cfgPath, JSON.stringify(this.originalV3DevConfig, null, "\t"));
				}
				resolve();
			} catch (err) {
				reject(err);
			}
		});
	}

	handleError(argument) {
		return this.beforeDone();
	}
}

module.exports = V3DevrcTask;