const Resource = require("./Resource");
const fileUtils = require("../../../utils/FileUtils");
const pathUtils = require("../../../utils/PathUtils");
const fs = require("fs");

class FileResource extends Resource{

	constructor(params) {
		super(params);
		this.source = params.source;
	}

	getContent() {
		return fs.readFileSync(this.source, "utf-8");
	}

	persistence() {
		fileUtils.makeDir(pathUtils.getParentPath(this.dist));
		fs.writeFileSync(this.dist, fs.readFileSync(this.source));
	}
}

module.exports = FileResource;