class Vjs {

	constructor(params) {
		this.name = params.name;
		this.version = params.version;
		this.dependencies = params.dependencies;
		this.services = params.services;
		this.modules = params.modules;
		this.implements = params.implements;
	}

	setName(name) {
		this.name = name;
	}

	getName() {
		return this.name;
	}

	setVersion(version) {
		this.version = version;
	}

	getVersion() {
		return this.version;
	}

	setDependencies(dependencies) {
		this.dependencies = dependencies;
	}

	getDependencies() {
		return this.dependencies;
	}

	setServices(services) {
		this.services = services;
	}

	getServices() {
		return this.services;
	}

	setModules(modules) {
		this.modules = modules;
	}

	getModules() {
		return this.modules;
	}

	setImplements(impls){
		this.implements = impls;
	}

	getImplements(){
		return this.implements;
	}

	toXmlObj() {
		let obj = {};
		let define = {};
		obj.define = define;
		define.name = this.name;
		define.version = this.version;
		let deps = [];
		define.deps = {
			dep: deps
		};
		if(this.implements){
			let impls = [];
			define.implements = {
				implement:impls
			};
			for (let i = 0, l = this.implements.length; i < l; i++) {
				let impl = this.implements[i];
				impls.push(impl.toXmlObj());
			}
		}
		if (this.dependencies && this.dependencies.length > 0) {
			for (let i = 0, l = this.dependencies.length; i < l; i++) {
				let dep = this.dependencies[i];
				deps.push(dep.toXmlObj());
			}
		}
		let services = [];
		define.services = {
			service: services
		};
		if (this.services && this.services.length > 0) {
			for (let i = 0, l = this.services.length; i < l; i++) {
				let service = this.services[i];
				services.push(service.toXmlObj());
			}
		}
		let children = [];
		obj.children = {
			child: children
		};
		if (this.modules) {
			for (let i = 0, l = this.modules.length; i < l; i++) {
				let module = this.modules[i];
				children.push(module.toXmlObj());
			}
		}
		return obj;
	}

}

module.exports = Vjs;