const postcss = require('postcss');
const fs = require('fs');
const path = require('path');
const pathUtls = require('../../utils/PathUtils');
const regex = /url\((.+?)\)/g;

const dealUrl = function(url){
    url = url.trim();
    let c = url.charAt(0);
    if(c=='"'||c=="'"){
        url = url.substring(1);
    }
    c = url.charAt(url.length-1);
    if(c=='"'||c=="'"){
        url = url.substring(0,url.length-1);
    }
    return url;
}

const cssHandler = postcss.plugin('css-res-scanner',(params)=>{
    return (root,result)=>{
        result.resList = [];
        root.walk(node=>{
            let val = node.value;
        });
        root.walkDecls((decl, i)=>{
            var val = decl.value;
            if(typeof(val)=='string'){
                while(regex.test(val)){
                    let url = RegExp.$1;
                    url = dealUrl(url);
                    //内嵌数据资源，则忽略
                    if(!(url.startsWith('data:')||url.startsWith("http:")||url.startsWith("https:"))){
                        url = url.split(/[?#]/)[0];
                        url = path.resolve(params.contextPath,url);
                        result.resList.push(url);
                    }
                }
            }
        });
    }
});

class CssScriptResScanner{
    constructor(path){
        this.path = path;
        this.contextPath = pathUtls.getParentPath(path);
    }

    scan(){
        return new Promise((resolve,reject)=>{
            let content = fs.readFileSync(this.path);
            if(content){
                postcss([cssHandler({
                    contextPath : this.contextPath
                })]).process(new String(content)).then(result=>{
                    resolve(result.resList);
                }).catch(err=>{
                    reject(err);
                });
            }
        });
    }
}

module.exports = CssScriptResScanner;