const configUtils = require('../../utils/ConfigUtils');
const constant = require('../../utils/Constant');
const stringUtils = require('../../utils/StringUtils');
const mavenUtils = require('../../utils/MavenUtils');
module.exports = {

    getArtifactId: function () {
        let v3DevConfig = configUtils.getV3DevConfig();
        return mavenUtils.getArtifactId(configUtils.getPluginType(), v3DevConfig.pluginCode);
    },

    getSymbolicName: function () {
        let v3DevConfig = configUtils.getV3DevConfig();
        return mavenUtils.getSymbolicName(this.getGroupId(), configUtils.getPluginType(), v3DevConfig.pluginCode);
    },

    getGroupId: function () {
        let v3DevConfig = configUtils.getV3DevConfig();
        return v3DevConfig.groupId ? v3DevConfig.groupId : constant.DEFAULT_GROUP_ID;
    },

    getMavenVersion: function (isCloudMode) {
        let v3DevConfig = configUtils.getV3DevConfig();
        let version = v3DevConfig.version;
        if(!version){
            throw new Error('.v3derc配置文件version信息缺失!');
        }
        return isCloudMode ? version:(version.endsWith("SNAPSHOT") ? version : version + ".SNAPSHOT");
    },

    getTagResourceVjsName: function (cmpName) {
        let componentName = cmpName || configUtils.getPluginCode();
        return constant.ARTIFACT_PREFIX + configUtils.getPluginType() + '.' + componentName;
    },

    getWidgetSkinVjsName : function(cmpName){
        return this.getTagResourceVjsName(cmpName)+".$skin";
    },

    toModuleId: function (vjsName, moduleName, version) {
        var buff = [];
        var c = stringUtils.toHashCode(vjsName);
        buff.push(c >= 0 ? c : "_" + Math.abs(c));
        buff.push("/");
        c = stringUtils.toHashCode(moduleName);
        buff.push(c >= 0 ? c : "_" + Math.abs(c));
        buff.push("_");
        var v = version.split(".");
        var subfix = v.pop();
        buff = buff.concat(v);
        buff.push("SNAPSHOT" == subfix ? "S" : subfix);
        return buff.join("");
    }

};