/**
 * @author xujw 2018-8-1 09:19:26
 * npm 脚本命令生成器基类,继承该类的其他脚本生成器类只需要重写getScripts方法,
 * 返回其对应的脚本命令对象即可
 */
const ioUtils = require('../../utils/IOUtils');
class ScriptGenerator {
    constructor(pluginPath, pluginConfig) {
        this.pluginPath = pluginPath;
        this.pluginConfig = pluginConfig;
        this.packageJson = require(this.getPluginPackageJsonPath());
    }
    /**
     * 获取插件路径
     */
    getPluginPath() {
        return this.pluginPath;
    }
    /**
     * 获取插件配置信息
     */
    getPluingConfig() {
        return this.pluginConfig;
    }

    getPluginPackageJsonPath() {
        return this.getPluginPath() + "/package.json";
    }
    /**
     * @abstract
     * 获取脚本命令对象
     */
    getScripts() {
        return this.packageJson.scripts;
    }
    /**
     * 生成scripts配置信息
     */
    generate() {
        this.packageJson.scripts = this.getScripts();
        return ioUtils.write(this.getPluginPackageJsonPath(), JSON.stringify(this.packageJson, null, "\t"));
    }

}

module.exports = ScriptGenerator;