const ScriptGenerator = require('../../model/ScriptGenerator');
/**
 * 控件执行脚本生成器，即在package.json的scripts节点中添加执行命令
 */
class ResourceScriptGenerator extends ScriptGenerator {

    /**
     * @override
     * 获取脚本命令对象
     */
    getScripts() {
        let scripts = this.packageJson.scripts || {};
        scripts["v3:package"] = "v3 webpack";
        scripts["v3:pack"] = "v3 pack";
        scripts["v3:publish"] = "v3 publish";
        scripts["v3:apply"] = "v3 apply";
        scripts["v3:install"] = "v3 install";
        scripts["v3:uninstall"] = "v3 uninstall";
        scripts["v3:test"] = "v3 test";
        return scripts;
    }
}

module.exports = ResourceScriptGenerator;