const WidgetScriptGenerator = require('./extends/WidgetScriptGenerator');
const WidgetWebpackCfgGenerator = require('./webpack/WidgetWebpackCfgGenerator');
const configUtils = require('../../utils/ConfigUtils');
const pathUtils = require('../../utils/PathUtils');
const WidgetCommand = require('./extends/WidgetCommand');
module.exports = {

    setPackageConfigs: function () {
        let promises = [];
        let v3DevConfig = configUtils.getV3DevConfig();
        let pluginPath = pathUtils.getPluginPath();
        let webpackGenerator = new WidgetWebpackCfgGenerator();
        let promise = webpackGenerator.generate();
        promises.push(promise);
        let inst = new WidgetScriptGenerator(pluginPath, v3DevConfig);
        let promise1 = inst.generate();
        promises.push(promise1);
        return new Promise((resolve, reject) => {
            Promise.all(promises).then(() => {
                resolve();
            }).catch(err => {
                reject(err);
            });
        });
    },

    exe: function (command,args) {
        return new WidgetCommand().getCmdFunction(command,args);
    },
    _handleError: function (err) {
        if (typeof (err) == 'string') {
            console.log(err);
        } else if (err.stack) {
            console.error(err.stack);
            console.error('错误信息: ' + err.message);
        } else {
            console.error('错误信息: ' + err.message);
        }
    }
};