const path = require('path');
const webpackCfgUtils = require('../../../utils/WebpackCfgUtils');
class WidgetWebpackCfgGenerator {
    constructor() {}
    createExtWebpackCfg() {
        let absPath = path.resolve(__dirname, './template/webpack.ext.config.tpl')
        return webpackCfgUtils.createFile(absPath, "build/webpack.ext.config.js");
    }
    createWebpackCfg() {
        let absPath = path.resolve(__dirname, './template/webpack.config.tpl');
        return webpackCfgUtils.createFile(absPath, "build/webpack.config.js");
    }
    createV3WebpackCfg() {
        let absPath = path.resolve(__dirname, './template/v3/webpack.v3.config.tpl');
        return webpackCfgUtils.createFile(absPath, "build/v3/webpack.v3.config.js");
    }
    generate() {
        let promises = [this.createWebpackCfg(), this.createExtWebpackCfg(), this.createV3WebpackCfg()];
        return new Promise((resolve, reject) => {
            Promise.all(promises).then(() => {
                resolve();
            }).catch((err) => {
                reject(err);
            });
        });
    }
    /**
     * 更新用户目录下的webpack配置文件,只覆盖webpack.config.js和webpack.v3.config.js
     */
    update() {
        let promises = [this.createWebpackCfg(), this.createV3WebpackCfg()];
        return new Promise((resolve, reject) => {
            Promise.all(promises).then(() => {
                resolve();
            }).catch((err) => {
                reject(err);
            });
        });
    }
}

module.exports = WidgetWebpackCfgGenerator;