var path  = require("path");
var fs = require("fs");

module.exports = {
  /**
   * 获取父目录路径
   */
  getParentPath: function(filePath) {
    return path.resolve(filePath,"..");
  },
  /**
   * 创建父目录
   */
  makeDir: function(filePath) {
    var iter = function(parent) {
      if (!fs.existsSync(parent)) {
        var f = this.getParentPath(parent);
        iter(f);
        fs.mkdirSync(parent);
      }
    };
    var parent = this.getParentPath(filePath);
    iter.call(this,parent);
    if (!fs.existsSync(filePath)) {
      fs.mkdirSync(filePath);
    }
  }
};
