var fs = require("fs");

module.exports = {

  _toWindowDistDir : function(){
    var pathArray = ["itop","resources"];
    return pathArray.join("/");
  },

  getComponentSrcPath : function(componentCode){
    return "src/components/"+componentCode;
  },

  getWindowSrcPath : function(componentCode,windowCode){
    return this.getComponentSrcPath(componentCode)+"/views/"+windowCode;
  },

  getWindowIndexPath : function(componentCode,windowCode){
    return this.getWindowSrcPath(componentCode,windowCode)+"/index.js";
  },

  getWindowPreviewIndexPath : function(componentCode,windowCode){
    return this.getWindowSrcPath(componentCode,windowCode)+"/test/previewIndex.js";
  },

  toWindowDistPath : function(componentCode,windowCode){
    var pathArray = [this._toWindowDistDir(),componentCode+"_"+windowCode+".lib"];
    return pathArray.join("/");
  },

  toWindowPreviewDistPath : function(componentCode,windowCode){
    /*var pathArray = [this._toWindowDir(componentCode,windowCode)];
    pathArray.push("previewIndex");
    return pathArray.join("/");*/
    return componentCode+"_"+windowCode+"_previewIndex";
  },

  toWindowPreviewHtmlDistPath : function(componentCode,windowCode){
    /*var pathArray = [this._toWindowDir(componentCode,windowCode)];
    pathArray.push("index.html");
    return pathArray.join("/");*/
    return componentCode+"_"+windowCode+".html";
  },

  toStaticResourcePathDir : function(){
    return "itop/resources";
  },

  getComponentResource : function(componentCode,resName){
    return "itop/resources/"+componentCode+"_"+resName;
  },

  getWidgetIndexVuePath : function(componentCode,windowCode,widgetCode){
    var pathArray = [this.getWindowSrcPath(componentCode,windowCode),widgetCode,"index.vue"];
    return pathArray.join("/");
  },

  toWidgetMetadataPath : function(componentCode,windowCode,widgetCode){
    var arr = [componentCode,windowCode,widgetCode,"metadata.json"];
    return arr.join('_');
  }

};
