const webpack = require('webpack');
let baseConfigs = require("./webpack.base.config.js");
const MetadataGenerator = require("../../generator/MetadataGenerator");

let configs = baseConfigs.configs;
let components = baseConfigs.components;
let plugins = [new webpack.DefinePlugin({
    'process.env': {
      NODE_ENV: '"production"'
    }
  }),
  new webpack.optimize.UglifyJsPlugin({
    sourceMap: true,
    compress: {
      warnings: false
    }
  }),
  new webpack.LoaderOptionsPlugin({
    minimize: true
  })
];

const generator = new MetadataGenerator(components);
generator.generate();
plugins = plugins.concat(configs.plugins);
configs.plugins = plugins;

//configs.devtool = '#source-map';

module.exports = configs;
