const pathUtils = require("../../utils/PathUtils");

module.exports = {

  getEntries: function (components) {
    let entry = {};
    components.forEach(component => {
      let componentCode = component.getCode();
      let windows = component.getWindows();
      if (windows && windows.length > 0) {
        windows.forEach(win => {
          let windowCode = win.getCode();
          entry[pathUtils.toWindowDistPath(componentCode, windowCode)] = win.getIndexPath();
          entry[pathUtils.toWindowPreviewDistPath(componentCode, windowCode)] = win.getPreviewIndexPath();
        });
      }
    });
    return entry;
  }
  
};