var ExtractTextPlugin = require('extract-text-webpack-plugin');
var postcss = require("postcss");
var postCssUrl = require("postcss-url");

module.exports = [{
  test: /\.css$/,
  use: ExtractTextPlugin.extract({
    fallback: "vue-style-loader",
    use: [
      "css-loader",
      { 
        loader: 'postcss-loader', 
        options: { 
          plugins: [
            require('autoprefixer')(),
            postCssUrl({   
              url: function(asset){
                  var res = asset.url;
                  if(res){
                      res = res.trim();
                      var prefix = res.indexOf("?")!=-1 ? '&':'?';
                      res = res + prefix + "cssRes=true"; 
                  }
                  return res;
              }
            })
          ]
        } 
      }
    ]
  })
},{
    test: /\.vue$/,
    loader: 'vue-loader',
    options: {
      loaders: {
        css: ExtractTextPlugin.extract({
          use: 'css-loader',
          fallback: 'vue-style-loader'
        }),
        less: ExtractTextPlugin.extract({
          use: 'css-loader!less-loader',
          fallback: 'vue-style-loader'
        })
      },
      postLoaders: {
        html: 'babel-loader'
      },
      postcss: {
        plugins: [
          require('autoprefixer')(),
          postCssUrl({   
            url: function(asset){
                var res = asset.url;
                if(res){
                    res = res.trim();
                    var prefix = res.indexOf("?")!=-1 ? '&':'?';
                    res = res + prefix + "cssRes=true"; 
                }
                return res;
            }
          })
        ]
      }
    }
  }, {
    test: /\.js$/,
    loader: 'babel-loader',
    exclude: /node_modules/
  }, {
    test: /\.ejs$/,
    loader: 'ejs-loader'
  }
];
