const webpack = require('webpack');
const path = require('path');
const pathUtils = require('../../../../utils/PathUtils');
const CopyWebpackPlugin = require('copy-webpack-plugin');
const HtmlWebpackPlugin = require('html-webpack-plugin');
const ExtractTextPlugin = require('extract-text-webpack-plugin');
const pluginPathUtils = require('../../utils/PathUtils');

module.exports = {
  getPlugins: function (components) {
    let componentCode = components[0].getCode();
    return [
      new webpack.HashedModuleIdsPlugin(),
      new CopyWebpackPlugin([{
        from: path.join(pathUtils.getSelfPath(), 'src/vendor/vplatform/assets'),
        to: path.join(pathUtils.getPluginPath(), 'dist/vendor/vplatform/assets')
      }]),
      new webpack.optimize.CommonsChunkPlugin({
        name: "vendor",
        filename: pluginPathUtils.getComponentResource(componentCode, "vendor.lib.js"),
      }),
      new HtmlWebpackPlugin({
        filename: 'index.html',
        template: path.join(pathUtils.getSelfPath(),'src/vendor/vplatform/index.html'),
        chunks: ["vendor", "index"]
      })
    ];
  }
};