const HtmlWebpackPlugin = require('html-webpack-plugin');
const pluginPathUtils = require('../../utils/PathUtils');
const pathUtils = require('../../../../utils/PathUtils');
const path = require('path');

module.exports = {

  getPlugins: function (components) {
    let plugins = [];
    components.forEach(component => {
      let componentCode = component.getCode();
      let wins = component.getWindows();
      if (wins) {
        wins.forEach(win => {
          let windowCode = win.getCode();
          let distPath = pluginPathUtils.toWindowDistPath(componentCode, windowCode);
          plugins.push(new HtmlWebpackPlugin({
            filename: pluginPathUtils.toWindowPreviewHtmlDistPath(componentCode, windowCode),
            template: path.join(pathUtils.getSelfPath(),'src/vendor/vplatform/windowPreview.html'),
            chunks: ["vendor", pluginPathUtils.toWindowDistPath(componentCode, windowCode), pluginPathUtils.toWindowPreviewDistPath(componentCode, windowCode)]
          }));
        });
      }
    });
    return plugins;
  }

};