const pathUtils = require("../../../../utils/PathUtils");
const ioUtils = require("../../../../utils/IOUtils");
const path = require("path");
const windowPreviewIndexTpl = require('../../../../vendor/vplatform/windowPreviewIndexTpl');
const pluginPathUtils = require('../../utils/PathUtils');

var Generator = function(components){
  this.components = components;
};

Generator.prototype = {
  generate : function(){
    var pluginPath = pathUtils.getPluginPath();
    for(var i=0,l=this.components.length;i<l;i++){
      var cmp = this.components[i];
      var componentCode = cmp.getCode();
      var wins = cmp.getWindows();
      if(wins){
        for(var j=0,len=wins.length;j<len;j++){
          var win = wins[j];
          var windowCode = win.getCode();
          var script = windowPreviewIndexTpl({
            componentCode : componentCode,
            windowCode : windowCode,
            widgets : win.getWidgets()
          });
          var relativePath = pluginPathUtils.getWindowPreviewIndexPath(componentCode,windowCode);
          ioUtils.writeContent(path.join(pluginPath,relativePath),script);
        }
      }
    }
  }
};

module.exports = Generator;
