const fs = require('fs');
const pathUtil = require('./PathUtils');
const fileUtils = require('./FileUtils');

module.exports = {
  /**
   * 将内容写入指定路径
   */
  writeContent: function(absPath, content) {
    fileUtils.makeDir(pathUtil.getParentPath(absPath));
    fs.writeFileSync(absPath, content);
  },
  /**
   * 异步将内容写入指定路径
   */
  writeContentAsync : function(absPath,content,callback){
    fileUtils.makeDir(pathUtil.getParentPath(absPath));
    fs.writeFile(absPath,content,callback);
  },

  /**
   * 写入文件
   */
  write : function(absPath,content){
    fileUtils.makeDir(pathUtil.getParentPath(absPath));
    return new Promise((resolve,reject)=>{
      fs.writeFile(absPath,content,(err)=>{
        if(err){
          reject(err);
          return;
        }
        resolve();
      });
    });
  }

};
