/**
 * @author xujw
 * 皮肤变量提取工具
 */
const configUtils = require('./ConfigUtils');
const pathUtils = require('./PathUtils');
const path = require('path');
const {
    SkinVarPreHandler
} = require('v3-skinhandler');

module.exports = {
    /**
     * 打包前的样式文件预处理，提取样式文件中的皮肤变量信息
     */
    skinPreHandle(aliasInfo) {
        return new Promise((resolve, reject) => {
            let v3cfg = configUtils.getV3DevConfig();
            let skinhandler = new SkinVarPreHandler({
                projPath: pathUtils.getPluginPath(),
                sourceRoot: path.resolve(pathUtils.getPluginPath(), 'src'),
                code: v3cfg.pluginCode,
                type: v3cfg.type,
                alias: aliasInfo
            });
            skinhandler.handleSkinVar().then(result => {
                return resolve(result);
            }).catch(err => {
                return reject(`${err}\n解析皮肤变量信息失败`);
            })
        });
    },
    /**
     * 打包完成后的样式处理,提供样式变量表，将样式文件中的样式表达式还原为样式变量值
     * @param skinVars 样式变量表
     */
    skinPostHandle(skinVars) {

    }
}